unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons, ComCtrls, Menus, Types, ExtCtrls, ZylNMEAGenerator,
  System.ComponentModel;

type

  TfrmMain = class(TForm)
    gbLat: TGroupBox;
    btnGenerate: TBitBtn;
    cmbLat: TComboBox;
    lblDegree: TLabel;
    lblMinute: TLabel;
    lblSecond: TLabel;
    gbLong: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cmbLong: TComboBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    Memo1: TMemo;
    btnTransmit: TBitBtn;
    GroupBox1: TGroupBox;
    efPort: TComboBox;
    btnConnect: TBitBtn;
    efLatDeg: TEdit;
    efLatMin: TEdit;
    efLongDeg: TEdit;
    efLongMin: TEdit;
    efLongSec: TEdit;
    efHeading: TEdit;
    efSpeed: TEdit;
    efAltitude: TEdit;
    efLatSec: TEdit;
    ZylNMEAGenerator: TZylNMEAGenerator;
    procedure FormCreate(Sender: TObject);
    procedure btnGenerateClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnTransmitClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
 
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cmbLat.ItemIndex := 0;
  cmbLong.ItemIndex := 0;
end;

procedure TfrmMain.btnGenerateClick(Sender: TObject);
begin
  ZylNMEAGenerator.Latitude_Degree := StrToInt(efLatDeg.Text);
  ZylNMEAGenerator.Latitude_Minute := StrToInt(efLatMin.Text);
  ZylNMEAGenerator.Latitude_Second := StrToFloat(efLatSec.Text);
  if cmbLat.Text = 'North' then
    ZylNMEAGenerator.Latitude_Direction := cpNorth
  else
    ZylNMEAGenerator.Latitude_Direction := cpSouth;
  ZylNMEAGenerator.Longitude_Degree := StrToInt(efLongDeg.Text);
  ZylNMEAGenerator.Longitude_Minute := StrToInt(efLongMin.Text);
  ZylNMEAGenerator.Longitude_Second := StrToFloat(efLongSec.Text);
  if cmbLong.Text = 'East' then
    ZylNMEAGenerator.Longitude_Direction := cpEast
  else
    ZylNMEAGenerator.Longitude_Direction := cpWest;
  ZylNMEAGenerator.Altitude := StrToFloat(efAltitude.Text);
  ZylNMEAGenerator.Heading := StrToFloat(efHeading.Text);
  ZylNMEAGenerator.Speed := ZylNMEAGenerator.KmhToKnots(StrToFloat(efSpeed.Text));

  Memo1.Lines.Text := ZylNMEAGenerator.GetNMEA;
end;

procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
  ZylNMEAGenerator.Connect(efPort.Text);
end;

procedure TfrmMain.btnTransmitClick(Sender: TObject);
begin
  ZylNMEAGenerator.Transmit;
end;

end.
